--0.16 circuit connectors:
require("circuit-connector-generated-definitions")

circuit_connector_definitions["cf-chests"] = circuit_connector_definitions.create
(
  universal_connector_template,
  {
    { variation = 1, main_offset = util.by_pixel(6+30, 5.5-10), shadow_offset = util.by_pixel(10.5+30, 7.5-10), show_shadow = true },
  }
)

  function make_variation(path,name_prefix,var,w,h,xs,ys)
  local v = {
	  priority ="extra-high",
	  filename = path..name_prefix..tostring(var)..".png",
	  width = w,
	  height = h,
	  shift = {xs,ys},
  }
  return v
  end
  
  
  

data:extend(
{
  { type = "technology", name = "compound-furnaces",
    icon = "__compound-furnaces__/graphics/item-group/compound-furnaces.png",
	icon_size = 128,
    effects =
    {
      {
        type = "unlock-recipe",
        recipe = "cf-elec-core"
      },
      {
        type = "unlock-recipe",
        recipe = "cf-elec-batch"
      },
      {
        type = "unlock-recipe",
        recipe = "cf-elec-speed"
      },	  
	  {
        type = "unlock-recipe",
        recipe = "cf-elec-input"
      },
      {
        type = "unlock-recipe",
        recipe = "cf-elec-output"
      },
      {
        type = "unlock-recipe",
        recipe = "cf-elec-output"
      },	  
      {
        type = "unlock-recipe",
        recipe = "cf-selector"
      },	  	  
	  
    },
    prerequisites = {"effect-transmission", "speed-module-3","productivity-module-3", "advanced-electronics-2","advanced-material-processing-2","logistics-3"},
    unit =
    {
      count = 400,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"high-tech-science-pack",1},
		{"production-science-pack", 1},
      },
      time = 60
    },
    upgrade = false,
    order = "i-e-c"
  },
  { type = "technology", name = "compound-furnace-logistic-connections",
    icon = "__compound-furnaces__/graphics/item-group/compound-furnace-logistic-connections.png",
	icon_size = 128,
    effects =
    {
	  {
        type = "unlock-recipe",
        recipe = "cf-elec-requester"
      },
      {
        type = "unlock-recipe",
        recipe = "cf-elec-passive-provider"
      },
    },
    prerequisites = {"compound-furnaces","logistic-system"},
    unit =
    {
      count = 200,
      ingredients =
      {
        {"science-pack-1", 1},
        {"science-pack-2", 1},
        {"science-pack-3", 1},
        {"high-tech-science-pack",1},
		{"production-science-pack", 1},
      },
      time = 60
    },
    upgrade = false,
    order = "i-e-c"
  },  
  { type = "item-group", name = "compound-furnaces",
    order = "e",
    icon = "__compound-furnaces__/graphics/item-group/compound-furnaces.png",
	icon_size = 128,
  },
  { type = "item-subgroup", name = "compound-electric-furnace",
    group = "compound-furnaces",
    order = "a",
  },
  { type = "item", name = "cf-elec-core",
    icon = "__compound-furnaces__/graphics/icons/electric-core.png",
	icon_size = 32,
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-core]",
    place_result = "cf-elec-core",
    stack_size = 5
  },
  { type = "item", name = "cf-elec-batch",
    icon = "__compound-furnaces__/graphics/icons/electric-batch.png",
	icon_size = 32,	
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-batch]",
    place_result = "cf-elec-batch",
    stack_size = 50
  },
  { type = "item", name = "cf-elec-input",
    icon = "__compound-furnaces__/graphics/icons/electric-input.png",
	icon_size = 32,
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-input]",
    place_result = "cf-elec-input",
    stack_size = 20
  },
  { type = "item", name = "cf-elec-output",
    icon = "__compound-furnaces__/graphics/icons/electric-output.png",
	icon_size = 32,	
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-output]",
    place_result = "cf-elec-output",
    stack_size = 20
  },
  { type = "item", name = "cf-elec-requester",
    icon = "__compound-furnaces__/graphics/icons/electric-requester.png",
	icon_size = 32,	
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-input]",
    place_result = "cf-elec-requester",
    stack_size = 20
  },
  { type = "item", name = "cf-elec-passive-provider",
    icon = "__compound-furnaces__/graphics/icons/electric-passive-provider.png",
	icon_size = 32,	
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-output]",
    place_result = "cf-elec-passive-provider",
    stack_size = 20
  },  
  { type = "item", name = "cf-elec-speed",
    icon = "__compound-furnaces__/graphics/icons/electric-speed.png",
	icon_size = 32,	
    flags = {"goes-to-quickbar"},
    subgroup = "compound-electric-furnace",
    order = "a[compound-electric-furnace]-a[cf-elec-speed]",
    place_result = "cf-elec-speed",
    stack_size = 50
  },  
  { type = "recipe", name = "cf-elec-core",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"steel-plate", 24},
      {"battery", 300},
	  {"processing-unit",100}
    },
    result = "cf-elec-core"
  },
  { type = "recipe", name = "cf-elec-batch",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"electric-furnace",1},
	  {"fast-inserter",2},
	  {"express-underground-belt",4},
	  {"productivity-module-3",2},
	  {"battery",10},
	  {"processing-unit",15},
	  
    },
    result = "cf-elec-batch"
  },
  { type = "recipe", name = "cf-elec-input",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"steel-plate", 15},
    },
    result = "cf-elec-input"
  },
  { type = "recipe", name = "cf-elec-output",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"steel-plate", 15},
    },
    result = "cf-elec-output"
  },
  { type = "recipe", name = "cf-elec-requester",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"steel-plate", 15},
	  {"processing-unit",5},
    },
    result = "cf-elec-requester"
  },
  { type = "recipe", name = "cf-elec-passive-provider",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"steel-plate", 15},
	  {"processing-unit",5},
    },
    result = "cf-elec-passive-provider"
  },
  { type = "recipe", name = "cf-elec-speed",
    energy_required = 10,
    enabled = false,
    ingredients =
    {
      {"beacon", 1},
      {"steel-plate", 15},
	  {"speed-module-3",2},
	  {"battery",10},
	  {"processing-unit",30},
	  
    },
    result = "cf-elec-speed"
  },
--[[explaination of cf-elec-core
the core acts as an uninterruptable power supply, collecting all the energy needed to process a cycle in advance.
MJ demands for full smelter:
1476KJ per smelter (180+720%)
88560KJ for 60 smelters
5313600KJ for 1 minute of 60 smelters
300KJ per speed building
30000KJ for 100 building
1800000KJ for 1 minute x 100 speed buildings
118560kW input flow limit on max design
130
]]--
  { type = "electric-energy-interface", name = "cf-elec-core",
    icon = "__compound-furnaces__/graphics/icons/electric-core.png",
	icon_size = 32,	
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 3, result = "cf-elec-core"},
    order = "s-e-w-f",	
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
	has_backer_name = true,		
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    energy_source =
    {
      type = "electric",
      buffer_capacity = "1500MJ",
      usage_priority = "secondary-input",
      input_flow_limit = "132MW",
      output_flow_limit = "0kW"
    },
    energy_production = "0kW",
    energy_usage = "0kW",
    -- also 'pictures' for 4-way sprite is available, or 'animation' resp. 'animations'
    picture =
    {
      filename = "__compound-furnaces__/graphics/entity/compound-furnace/electric-core-temp.png",
      priority = "extra-high",
      width = 133,
      height = 133,
      shift = {x=0.5625, y=-0.59375}
    },
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    working_sound =
    {
      sound =
      {
        filename = "__base__/sound/accumulator-working.ogg",
        volume = 0.4
      },
      idle_sound = {
        filename = "__base__/sound/accumulator-idle.ogg",
        volume = 0.4
      },
      max_sounds_per_type = 2
    },
  },
  { type = "simple-entity-with-force", name = "cf-elec-batch",
	render_layer = "object",
    icon = "__compound-furnaces__/graphics/icons/electric-batch.png",
	icon_size = 32,		
    flags = {"placeable-neutral", "player-creation"},
	order = "s-e-w-f",
    minable = {mining_time = 3, result = "cf-elec-batch"},
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    pictures=
    {
      layers = {
      {
        filename = "__base__/graphics/entity/electric-furnace/electric-furnace-base.png",
        priority = "high",
        width = 129,
        height = 100,
        frame_count = 1,
        shift = {0.421875, 0},
        hr_version = {
          filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace.png",
          priority = "high",
          width = 239,
          height = 219,
          frame_count = 1,
          shift = util.by_pixel(0.75, 5.75),
          scale = 0.5
        }
      },
      {
        filename = "__base__/graphics/entity/electric-furnace/electric-furnace-shadow.png",
        priority = "high",
        width = 129,
        height = 100,
        frame_count = 1,
        shift = {0.421875, 0},
        draw_as_shadow = true,
        hr_version = {
          filename = "__base__/graphics/entity/electric-furnace/hr-electric-furnace-shadow.png",
          priority = "high",
          width = 227,
          height = 171,
          frame_count = 1,
          draw_as_shadow = true,
          shift = util.by_pixel(11.25, 7.75),
          scale = 0.5
        }
      }
      }
	}
  },
  { type = "simple-entity-with-force", name = "cf-elec-speed",
    render_layer = "object",	
    icon = "__compound-furnaces__/graphics/icons/electric-speed.png",
	icon_size = 32,	
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 3, result = "cf-elec-speed"},
	order = "s-e-w-f",
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__compound-furnaces__/graphics/entity/compound-furnace/electric-speed-copied.png",
      width = 175,--116
      height = 126,--93
      shift = {x=1.1875,y=-0.3275}
    },
  },
  { type = "container", name = "cf-elec-input",
    icon = "__compound-furnaces__/graphics/icons/electric-input.png",
	icon_size = 32,	
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "cf-elec-input"},
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
	has_backer_name = true,
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    fast_replaceable_group = "cf-electric-container",
    inventory_size = 48,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__compound-furnaces__/graphics/entity/compound-furnace/electric-input-temp.png",
      priority = "extra-high",
      width = 133,
      height = 133,
      shift = {x=0.5625, y=-0.59375}
    },
    circuit_wire_connection_point = circuit_connector_definitions["cf-chests"].points,
    circuit_wire_max_distance = 9,
	circuit_connector_sprites = circuit_connector_definitions["cf-chests"].sprites,	
  },
  { type = "container", name = "cf-elec-output",
    icon = "__compound-furnaces__/graphics/icons/electric-output.png",
	icon_size = 32,	
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "cf-elec-output"},
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
	has_backer_name = true,	
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    fast_replaceable_group = "cf-electric-container",
    inventory_size = 48,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__compound-furnaces__/graphics/entity/compound-furnace/electric-output-temp.png",
      priority = "extra-high",
      width = 133,
      height = 133,
      shift = {x=0.5625, y=-0.59375}
    },
    circuit_wire_connection_point = circuit_connector_definitions["cf-chests"].points,
    circuit_wire_max_distance = 9,
	circuit_connector_sprites = circuit_connector_definitions["cf-chests"].sprites,	
  },
  { type = "logistic-container", name = "cf-elec-requester",
    icon = "__compound-furnaces__/graphics/icons/electric-input.png",
	icon_size = 32,	
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "cf-elec-requester"},
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
	has_backer_name = true,
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    fast_replaceable_group = "cf-electric-container",
    logistic_mode = "requester",	
    inventory_size = 48,
    logistic_slots_count = 12,	
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__compound-furnaces__/graphics/entity/compound-furnace/electric-requester-temp.png",
      priority = "extra-high",
      width = 133,
      height = 133,
      shift = {x=0.5625, y=-0.59375}
    },
    circuit_wire_connection_point = circuit_connector_definitions["cf-chests"].points,
    circuit_wire_max_distance = 9,
	circuit_connector_sprites = circuit_connector_definitions["cf-chests"].sprites,	
	
  },
  { type = "logistic-container", name = "cf-elec-passive-provider",
    icon = "__compound-furnaces__/graphics/icons/electric-output.png",
	icon_size = 32,	
    flags = {"placeable-neutral", "player-creation"},
    minable = {mining_time = 1, result = "cf-elec-passive-provider"},
    max_health = 150,
    corpse = "medium-remnants",
	dying_explosion = "medium-explosion",
	has_backer_name = true,	
    open_sound = { filename = "__base__/sound/metallic-chest-open.ogg", volume=0.65 },
    close_sound = { filename = "__base__/sound/metallic-chest-close.ogg", volume = 0.7 },
    resistances =
    {
      {
        type = "fire",
        percent = 80
      }
    },
    collision_box = {{-1.35, -1.35}, {1.35, 1.35}},
    selection_box = {{-1.5, -1.5}, {1.5, 1.5}},
    fast_replaceable_group = "cf-electric-container",
	logistic_mode = "passive-provider",
    inventory_size = 48,
    vehicle_impact_sound =  { filename = "__base__/sound/car-metal-impact.ogg", volume = 0.65 },
    picture =
    {
      filename = "__compound-furnaces__/graphics/entity/compound-furnace/electric-passive-temp.png",
      priority = "extra-high",
      width = 133,
      height = 133,
      shift = {x=0.5625, y=-0.59375}
    },
    circuit_wire_connection_point = circuit_connector_definitions["cf-chests"].points,
    circuit_wire_max_distance = 9,
	circuit_connector_sprites = circuit_connector_definitions["cf-chests"].sprites,	
  },  
  })